=begin
#Figshare API

#Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.32

=end

require 'date'

module SwaggerClient
  class ArticleCompletePrivate
    # Article public url
    attr_accessor :figshare_url

    # If true, downloading of files for this article is disabled
    attr_accessor :download_disabled

    # List of article files
    attr_accessor :files

    # List of article authors
    attr_accessor :authors

    # List of custom fields values
    attr_accessor :custom_fields

    # List of embargo options
    attr_accessor :embargo_options

    # Article citation
    attr_accessor :citation

    # Confidentiality reason
    attr_accessor :confidential_reason

    # Article Confidentiality
    attr_accessor :is_confidential

    # Article size
    attr_accessor :size

    # Article funding
    attr_accessor :funding

    # Full Article funding information
    attr_accessor :funding_list

    # List of article tags
    attr_accessor :tags

    # Article version
    attr_accessor :version

    # True if article is active
    attr_accessor :is_active

    # True if article has no files
    attr_accessor :is_metadata_record

    # Article metadata reason
    attr_accessor :metadata_reason

    # Article status
    attr_accessor :status

    # Article description
    attr_accessor :description

    # True if article is embargoed
    attr_accessor :is_embargoed

    # True if article is published
    attr_accessor :is_public

    # Date when article was created
    attr_accessor :created_date

    # True if any files are linked to the article
    attr_accessor :has_linked_file

    # List of categories selected for the article
    attr_accessor :categories

    # Article selected license
    attr_accessor :license

    # Title for embargo
    attr_accessor :embargo_title

    # Reason for embargo
    attr_accessor :embargo_reason

    # List of references
    attr_accessor :references

    # List of related materials; supersedes references and resource DOI/title.
    attr_accessor :related_materials

    # Unique identifier for article
    attr_accessor :id

    # Title of article
    attr_accessor :title

    # DOI
    attr_accessor :doi

    # Handle
    attr_accessor :handle

    # Api endpoint for article
    attr_accessor :url

    # Public site endpoint for article
    attr_accessor :url_public_html

    # Public Api endpoint for article
    attr_accessor :url_public_api

    # Private site endpoint for article
    attr_accessor :url_private_html

    # Private Api endpoint for article
    attr_accessor :url_private_api

    # Various timeline dates
    attr_accessor :timeline

    # Thumbnail image
    attr_accessor :thumb

    # Type of article identifier
    attr_accessor :defined_type

    # Name of the article type identifier
    attr_accessor :defined_type_name

    # ID of the account owning the article
    attr_accessor :account_id

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'figshare_url' => :'figshare_url',
        :'download_disabled' => :'download_disabled',
        :'files' => :'files',
        :'authors' => :'authors',
        :'custom_fields' => :'custom_fields',
        :'embargo_options' => :'embargo_options',
        :'citation' => :'citation',
        :'confidential_reason' => :'confidential_reason',
        :'is_confidential' => :'is_confidential',
        :'size' => :'size',
        :'funding' => :'funding',
        :'funding_list' => :'funding_list',
        :'tags' => :'tags',
        :'version' => :'version',
        :'is_active' => :'is_active',
        :'is_metadata_record' => :'is_metadata_record',
        :'metadata_reason' => :'metadata_reason',
        :'status' => :'status',
        :'description' => :'description',
        :'is_embargoed' => :'is_embargoed',
        :'is_public' => :'is_public',
        :'created_date' => :'created_date',
        :'has_linked_file' => :'has_linked_file',
        :'categories' => :'categories',
        :'license' => :'license',
        :'embargo_title' => :'embargo_title',
        :'embargo_reason' => :'embargo_reason',
        :'references' => :'references',
        :'related_materials' => :'related_materials',
        :'id' => :'id',
        :'title' => :'title',
        :'doi' => :'doi',
        :'handle' => :'handle',
        :'url' => :'url',
        :'url_public_html' => :'url_public_html',
        :'url_public_api' => :'url_public_api',
        :'url_private_html' => :'url_private_html',
        :'url_private_api' => :'url_private_api',
        :'timeline' => :'timeline',
        :'thumb' => :'thumb',
        :'defined_type' => :'defined_type',
        :'defined_type_name' => :'defined_type_name',
        :'account_id' => :'account_id'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'figshare_url' => :'String',
        :'download_disabled' => :'BOOLEAN',
        :'files' => :'Array<PublicFile>',
        :'authors' => :'Array<Author>',
        :'custom_fields' => :'Array<CustomArticleField>',
        :'embargo_options' => :'Array<GroupEmbargoOptions>',
        :'citation' => :'String',
        :'confidential_reason' => :'String',
        :'is_confidential' => :'BOOLEAN',
        :'size' => :'Integer',
        :'funding' => :'String',
        :'funding_list' => :'Array<FundingInformation>',
        :'tags' => :'Array<String>',
        :'version' => :'Integer',
        :'is_active' => :'BOOLEAN',
        :'is_metadata_record' => :'BOOLEAN',
        :'metadata_reason' => :'String',
        :'status' => :'String',
        :'description' => :'String',
        :'is_embargoed' => :'BOOLEAN',
        :'is_public' => :'BOOLEAN',
        :'created_date' => :'String',
        :'has_linked_file' => :'BOOLEAN',
        :'categories' => :'Array<Category>',
        :'license' => :'License',
        :'embargo_title' => :'String',
        :'embargo_reason' => :'String',
        :'references' => :'Array<String>',
        :'related_materials' => :'Array<RelatedMaterial>',
        :'id' => :'Integer',
        :'title' => :'String',
        :'doi' => :'String',
        :'handle' => :'String',
        :'url' => :'String',
        :'url_public_html' => :'String',
        :'url_public_api' => :'String',
        :'url_private_html' => :'String',
        :'url_private_api' => :'String',
        :'timeline' => :'Timeline',
        :'thumb' => :'String',
        :'defined_type' => :'Integer',
        :'defined_type_name' => :'String',
        :'account_id' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'figshare_url')
        self.figshare_url = attributes[:'figshare_url']
      end

      if attributes.has_key?(:'download_disabled')
        self.download_disabled = attributes[:'download_disabled']
      end

      if attributes.has_key?(:'files')
        if (value = attributes[:'files']).is_a?(Array)
          self.files = value
        end
      end

      if attributes.has_key?(:'authors')
        if (value = attributes[:'authors']).is_a?(Array)
          self.authors = value
        end
      end

      if attributes.has_key?(:'custom_fields')
        if (value = attributes[:'custom_fields']).is_a?(Array)
          self.custom_fields = value
        end
      end

      if attributes.has_key?(:'embargo_options')
        if (value = attributes[:'embargo_options']).is_a?(Array)
          self.embargo_options = value
        end
      end

      if attributes.has_key?(:'citation')
        self.citation = attributes[:'citation']
      end

      if attributes.has_key?(:'confidential_reason')
        self.confidential_reason = attributes[:'confidential_reason']
      end

      if attributes.has_key?(:'is_confidential')
        self.is_confidential = attributes[:'is_confidential']
      end

      if attributes.has_key?(:'size')
        self.size = attributes[:'size']
      end

      if attributes.has_key?(:'funding')
        self.funding = attributes[:'funding']
      end

      if attributes.has_key?(:'funding_list')
        if (value = attributes[:'funding_list']).is_a?(Array)
          self.funding_list = value
        end
      end

      if attributes.has_key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end

      if attributes.has_key?(:'version')
        self.version = attributes[:'version']
      end

      if attributes.has_key?(:'is_active')
        self.is_active = attributes[:'is_active']
      end

      if attributes.has_key?(:'is_metadata_record')
        self.is_metadata_record = attributes[:'is_metadata_record']
      end

      if attributes.has_key?(:'metadata_reason')
        self.metadata_reason = attributes[:'metadata_reason']
      end

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'is_embargoed')
        self.is_embargoed = attributes[:'is_embargoed']
      end

      if attributes.has_key?(:'is_public')
        self.is_public = attributes[:'is_public']
      end

      if attributes.has_key?(:'created_date')
        self.created_date = attributes[:'created_date']
      end

      if attributes.has_key?(:'has_linked_file')
        self.has_linked_file = attributes[:'has_linked_file']
      end

      if attributes.has_key?(:'categories')
        if (value = attributes[:'categories']).is_a?(Array)
          self.categories = value
        end
      end

      if attributes.has_key?(:'license')
        self.license = attributes[:'license']
      end

      if attributes.has_key?(:'embargo_title')
        self.embargo_title = attributes[:'embargo_title']
      end

      if attributes.has_key?(:'embargo_reason')
        self.embargo_reason = attributes[:'embargo_reason']
      end

      if attributes.has_key?(:'references')
        if (value = attributes[:'references']).is_a?(Array)
          self.references = value
        end
      end

      if attributes.has_key?(:'related_materials')
        if (value = attributes[:'related_materials']).is_a?(Array)
          self.related_materials = value
        end
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'title')
        self.title = attributes[:'title']
      end

      if attributes.has_key?(:'doi')
        self.doi = attributes[:'doi']
      end

      if attributes.has_key?(:'handle')
        self.handle = attributes[:'handle']
      end

      if attributes.has_key?(:'url')
        self.url = attributes[:'url']
      end

      if attributes.has_key?(:'url_public_html')
        self.url_public_html = attributes[:'url_public_html']
      end

      if attributes.has_key?(:'url_public_api')
        self.url_public_api = attributes[:'url_public_api']
      end

      if attributes.has_key?(:'url_private_html')
        self.url_private_html = attributes[:'url_private_html']
      end

      if attributes.has_key?(:'url_private_api')
        self.url_private_api = attributes[:'url_private_api']
      end

      if attributes.has_key?(:'timeline')
        self.timeline = attributes[:'timeline']
      end

      if attributes.has_key?(:'thumb')
        self.thumb = attributes[:'thumb']
      end

      if attributes.has_key?(:'defined_type')
        self.defined_type = attributes[:'defined_type']
      end

      if attributes.has_key?(:'defined_type_name')
        self.defined_type_name = attributes[:'defined_type_name']
      end

      if attributes.has_key?(:'account_id')
        self.account_id = attributes[:'account_id']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @id.nil?
        invalid_properties.push('invalid value for "id", id cannot be nil.')
      end

      if @title.nil?
        invalid_properties.push('invalid value for "title", title cannot be nil.')
      end

      if @doi.nil?
        invalid_properties.push('invalid value for "doi", doi cannot be nil.')
      end

      if @handle.nil?
        invalid_properties.push('invalid value for "handle", handle cannot be nil.')
      end

      if @url.nil?
        invalid_properties.push('invalid value for "url", url cannot be nil.')
      end

      if @url_public_html.nil?
        invalid_properties.push('invalid value for "url_public_html", url_public_html cannot be nil.')
      end

      if @url_public_api.nil?
        invalid_properties.push('invalid value for "url_public_api", url_public_api cannot be nil.')
      end

      if @url_private_html.nil?
        invalid_properties.push('invalid value for "url_private_html", url_private_html cannot be nil.')
      end

      if @url_private_api.nil?
        invalid_properties.push('invalid value for "url_private_api", url_private_api cannot be nil.')
      end

      if @timeline.nil?
        invalid_properties.push('invalid value for "timeline", timeline cannot be nil.')
      end

      if @thumb.nil?
        invalid_properties.push('invalid value for "thumb", thumb cannot be nil.')
      end

      if @defined_type.nil?
        invalid_properties.push('invalid value for "defined_type", defined_type cannot be nil.')
      end

      if @defined_type_name.nil?
        invalid_properties.push('invalid value for "defined_type_name", defined_type_name cannot be nil.')
      end

      if @account_id.nil?
        invalid_properties.push('invalid value for "account_id", account_id cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @id.nil?
      return false if @title.nil?
      return false if @doi.nil?
      return false if @handle.nil?
      return false if @url.nil?
      return false if @url_public_html.nil?
      return false if @url_public_api.nil?
      return false if @url_private_html.nil?
      return false if @url_private_api.nil?
      return false if @timeline.nil?
      return false if @thumb.nil?
      return false if @defined_type.nil?
      return false if @defined_type_name.nil?
      return false if @account_id.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          figshare_url == o.figshare_url &&
          download_disabled == o.download_disabled &&
          files == o.files &&
          authors == o.authors &&
          custom_fields == o.custom_fields &&
          embargo_options == o.embargo_options &&
          citation == o.citation &&
          confidential_reason == o.confidential_reason &&
          is_confidential == o.is_confidential &&
          size == o.size &&
          funding == o.funding &&
          funding_list == o.funding_list &&
          tags == o.tags &&
          version == o.version &&
          is_active == o.is_active &&
          is_metadata_record == o.is_metadata_record &&
          metadata_reason == o.metadata_reason &&
          status == o.status &&
          description == o.description &&
          is_embargoed == o.is_embargoed &&
          is_public == o.is_public &&
          created_date == o.created_date &&
          has_linked_file == o.has_linked_file &&
          categories == o.categories &&
          license == o.license &&
          embargo_title == o.embargo_title &&
          embargo_reason == o.embargo_reason &&
          references == o.references &&
          related_materials == o.related_materials &&
          id == o.id &&
          title == o.title &&
          doi == o.doi &&
          handle == o.handle &&
          url == o.url &&
          url_public_html == o.url_public_html &&
          url_public_api == o.url_public_api &&
          url_private_html == o.url_private_html &&
          url_private_api == o.url_private_api &&
          timeline == o.timeline &&
          thumb == o.thumb &&
          defined_type == o.defined_type &&
          defined_type_name == o.defined_type_name &&
          account_id == o.account_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [figshare_url, download_disabled, files, authors, custom_fields, embargo_options, citation, confidential_reason, is_confidential, size, funding, funding_list, tags, version, is_active, is_metadata_record, metadata_reason, status, description, is_embargoed, is_public, created_date, has_linked_file, categories, license, embargo_title, embargo_reason, references, related_materials, id, title, doi, handle, url, url_public_html, url_public_api, url_private_html, url_private_api, timeline, thumb, defined_type, defined_type_name, account_id].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
